


void AutoItserialINOUT() {   //by andy at autoit.de

  if (stringComplete) {     //serial data received

    // safe the IN or OUT-state of the ports
    // PORT register controls whether the pin is HIGH or LOW
    // PIN register controls whether the pin is READ or WRITE
    // DDR register controls whether the pin is INPUT or OUTPUT
    // https://www.arduino.cc/en/Reference/PortManipulation
    byte safestateofportsDDRD = DDRD | B11111100; //http://tronixstuff.com/2011/10/22/tutorial-arduino-port-manipulation/
    byte safestateofportsDDRB = DDRB;
    byte safestateofportsDDRC = DDRC;
    byte safestateofportsPORTD = PORTD;
    byte safestateofportsPORTB = PORTB;
    byte safestateofportsPORTC = PORTC;

    inputString.trim();    //kill CRLF

     if (inputString == "ArduinoDebugMode=True") {AutoItDebugMode = true;}
     if (inputString == "ArduinoDebugMode=False") {AutoItDebugMode = false;}

  //   Serial.print( AutoItDebugMode);



    int portnumberAI = inputString.substring(2, 4).toInt();  //second and third character

    if (inputString.charAt(0) == 'd') {  //digital command send?

      if (AutoItDebugMode == true) {Serial.print(inputString + "  DIGITALPORT = " + String(portnumberAI));}

      if (inputString.charAt(1) == 'w') {  //write command send by AutoIt?
        if (AutoItDebugMode == true) {Serial.print(" Read/Write = WRITE" );}
        pinMode(portnumberAI, OUTPUT);
        if (inputString.charAt(4) == '1') {  //HIGH command send by AutoIt?
          if (AutoItDebugMode == true) {Serial.print(" High/Low = HIGH" );}
          digitalWrite(portnumberAI, HIGH);   // turn the port to HIGH
        }
        else {
          if (AutoItDebugMode == true) {Serial.print(" High/Low = LOW" );}
          digitalWrite(portnumberAI, LOW);   // turn the port to LOW
        }
      }
      if (inputString.charAt(1) == 'r') {  //read command send by AutoIt?
        if (AutoItDebugMode == true) {Serial.print(" Read/Write = READ" );}
        pinMode(portnumberAI, INPUT);      //we want to read data -> INPUT
        int readval = digitalRead(portnumberAI);
        if (readval == 1) {
          if (AutoItDebugMode == true) {Serial.print(" High/Low = ");}
          Serial.print("HIGH");
        }
        else {
          if (AutoItDebugMode == true) {Serial.print(" High/Low = ");}
          Serial.print("LOW" );
        }
      }

    }

    if (inputString.charAt(0) == 'a') {  //analog command
      if (AutoItDebugMode == true) {Serial.print(inputString + "  ANALOGPORT = " + String(portnumberAI));}

      if (inputString.charAt(1) == 'w') {  //write command
        if (AutoItDebugMode == true) {Serial.print(" Read/Write = WRITE" );}
        pinMode(portnumberAI, OUTPUT);
        int valueAI = inputString.substring(4, 7).toInt();
        if (AutoItDebugMode == true) {Serial.print(" val = " + String(valueAI));}
        analogWrite(portnumberAI, valueAI);   // writes 0-255 to port
      }
      if (inputString.charAt(1) == 'r') {  //read command
        if (AutoItDebugMode == true) {Serial.print(" Read/Write = READ" );}
        pinMode(portnumberAI, INPUT);
        int valueAI = analogRead(portnumberAI);   // read analog value from 0 to 1023
        if (AutoItDebugMode == true) {Serial.print(" val = ");}
        Serial.print(String(valueAI));
      }

    }


    inputString = "";
    stringComplete = false;
    Serial.println();   // set CRLF to tell AutoIt that the String is finished

    //restore state of ports , if necessary
    //Bit 0 and 1 of DDRD-register is RX and TX
    DDRD = safestateofportsDDRD | B11111100; //http://tronixstuff.com/2011/10/22/tutorial-arduino-port-manipulation/
    DDRB = safestateofportsDDRB;
    DDRC = safestateofportsDDRC;


    //  if you restore the PORT-register here, it is possibly/surely to "overwrite" the settings of written pins
    //    PORTD=safestateofportsPORTD;
    //    PORTB=safestateofportsPORTB;
    //    PORTC=safestateofportsPORTC;

  }

}


/*
  SerialEvent occurs whenever a new data comes in the
 hardware serial RX.  This routine is run between each
 time loop() runs, so using delay inside loop can delay
 response.  Multiple bytes of data may be available.
 */
void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    char inChar = (char)Serial.read();
    // add it to the inputString:
    inputString += inChar;
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:
    if (inChar == '\n') {
      stringComplete = true;
    }
  }
  AutoItserialINOUT();  //reads/writes Commands from/to AutoIt
}


