#include "CommMG.au3"

;original by
;rewritten by andy at autoit.de

Global $ArduinoDebugMode = False


Func ArduinoSerialSend($message)
    $x = _CommSendString($message & @CRLF, 1)
    $r = _CommGetLine(@CR, '', 500)
    ;If $ArduinoDebugMode Then
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : Message(' & $message & '), Arduino returns : ' & StringStripWS($r, 1) & @CRLF)
EndFunc                            ;==>ArduinoSerialSend

Func ArduinoConnect($port, $baud)
    If $baud = "" Then $baud = 9600
    Local $sportSetError
    ConsoleWrite(_CommListPorts(1))
    _CommSetPort($port, $sportSetError, $baud, 8, "none", 2, 1)
    If @error Then
        ConsoleWrite(@error)
        If @error = -16 Then
            MsgBox(0, "", "arduino no encontrado en ese puerto =P")
        EndIf
    EndIf
EndFunc                            ;==>ArduinoConnect

Func digitalwrite($pin, $val)      ;$val must be 0 or 1
    If $pin < 10 Then $pin = 0 & $pin
    $x = _CommSendString("dw" & $pin & $val & @CRLF, 1)
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $x = ' & $x & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    $r = _CommGetLine(@CR, '', 500)
    If $ArduinoDebugMode Then ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : digitalwrite(), Arduino returns : ' & StringStripWS($r, 1) & @CRLF)
    If $r = $pin & "ok" Then
        Return 1
    Else
        SetError(1)
    EndIf
EndFunc                            ;==>digitalwrite

Func digitalread($pin)
    If $pin < 10 Then $pin = 0 & $pin
    _CommSendString("dr" & $pin & @CRLF, 1)
    $r = _CommGetLine(@CR, '', 500)
    If $ArduinoDebugMode Then ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : digitalread(), Arduino returns : ' & StringStripWS($r, 1) & @CRLF)
    If $r <> "" Then
        Return $r
    Else
        SetError(1)
    EndIf
EndFunc                            ;==>digitalread

Func analogwrite($pin, $val)       ;$val must be a value between 0 and 255
    If $pin < 10 Then $pin = 0 & $pin
    $val = StringTrimRight("000", StringLen($val)) & String($val)
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $val = ' & $val & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    $x = _CommSendString("aw" & $pin & $val & @CRLF, 1)
;~      ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $x = ' & $x & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    $r = _CommGetLine(@CR, '', 500)
    If $ArduinoDebugMode Then ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : analogwrite(), Arduino returns : ' & StringStripWS($r, 1) & @CRLF)
    If $r = $pin & "ok" Then
        Return 1
    Else
        SetError(1)
    EndIf
EndFunc                            ;==>analogwrite

Func analogread($pin)
    If $pin < 10 Then $pin = 0 & $pin
    _CommSendString("ar" & $pin & @CRLF, 1)
    $r = _CommGetLine(@CR, '', 500)

    If $ArduinoDebugMode Then
        ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : analogread(), Arduino returns : ' & StringStripWS($r, 1) & @CRLF)
    Else
        $r = StringStripWS($r, 8)
    EndIf
    If $r <> "" Then
        Return StringStripWS($r, 1)
    Else
        SetError(1)
    EndIf
EndFunc                            ;==>analogread

Func ArduinoClose()
    _CommClearOutputBuffer()
    _CommClearInputBuffer()
    _CommClosePort()
EndFunc                            ;==>ArduinoClose


